// CS 202, Fall 2007
//
// Author     : Harish Kumar
// Problem    : Prob 1
// Assignment : 3
// Date       : Sept 23 2006

// Fig. 9.2: Time.cpp
// Member-function definitions for class Time.
#include <iostream>
using std::cout;

#include <iomanip>
using std::setfill;
using std::setw;

#include <ctime>

#include "Time.h" // include definition of class Time from Time.h

// Time constructor initializes each data member to current hour,minute and second.
// Ensures all Time objects start in a consistent state.
Time::Time() 
{ 
   time_t current; // Declares a variable of type time_t (system declared long int)
//   struct tm *t; // Declares a pointer to the structure tm
   current = time(NULL); // Gets current time and stores into current variable

     second = current % 60;
     minute = (current/60) % 60;
     hour = (current/3600) % 24;
	
//   t= localtime(&current); // Converting time_t value to tm structure as local time
   
//   hour =  t->tm_hour; // Storing hour value stored in struct into hour
//   minute = t->tm_min; // Storing min value stored in struct into minute
//   second =  t->tm_sec;// Storing sec value stored in struct into second
} // end Time constructor

// set new Time value using universal time; ensure that
// the data remains consistent by setting invalid values to zero
void Time::setTime( int h, int m, int s )
{
   hour = ( h >= 0 && h < 24 ) ? h : 0; // validate hour
   minute = ( m >= 0 && m < 60 ) ? m : 0; // validate minute
   second = ( s >= 0 && s < 60 ) ? s : 0; // validate second
} // end function setTime

// print Time in universal-time format (HH:MM:SS)
void Time::printUniversal()
{
   cout << setfill( '0' ) << setw( 2 ) << hour << ":" 
      << setw( 2 ) << minute << ":" << setw( 2 ) << second;
} // end function printUniversal

// print Time in standard-time format (HH:MM:SS AM or PM)
void Time::printStandard()
{
   cout << ( ( hour == 0 || hour == 12 ) ? 12 : hour % 12 ) << ":" 
      << setfill( '0' ) << setw( 2 ) << minute << ":" << setw( 2 )
      << second << ( hour < 12 ? " AM" : " PM" );
} // end function printStandard

/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
